package cn.ibizlab.core.lite.extensions.domain;

import cn.ibizlab.core.lite.domain.MetaField;
import cn.ibizlab.core.lite.domain.MetaRelationship;
import lombok.Data;
import org.springframework.util.DigestUtils;
import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;
import java.util.*;

@Data
public class SysModel {

    private String systemid;

    private String systemname;

    private List<MetaEntityModel> entities;
    /**
     * 获取实体属性
     * @return
     */
    public Set<MetaField>  getField(){
        Set<MetaField> fields=new HashSet<>();
        this.entities.forEach(entityNode->{
            List<MetaField> deField=entityNode.getFields();
            if(!ObjectUtils.isEmpty(deField)){
                deField.forEach(field->{
                    String refDEId="";
                    String refFieldId="";
                    String curDEId=DigestUtils.md5DigestAsHex(String.format("%s||%s" ,systemid,entityNode.getEntityName()).getBytes());
                    Object refDEName=field.get("ref_de");
                    Object refFieldName=field.getRefFieldName();
                    Object relationCodeName=field.get("relation_codename");
                    field.setEntityId(curDEId);
                    if( !ObjectUtils.isEmpty(refDEName) && !ObjectUtils.isEmpty(refFieldName)){
                        refDEId=DigestUtils.md5DigestAsHex(String.format("%s||%s" ,systemid,refDEName).getBytes());
                        refFieldId=DigestUtils.md5DigestAsHex(String.format("%s||%s" ,refDEId,refFieldName).getBytes());
                        field.setRefFieldId(refFieldId);
                    }
                    if(!ObjectUtils.isEmpty(curDEId) && !ObjectUtils.isEmpty(refDEId) && !ObjectUtils.isEmpty(relationCodeName)){
                        field.setRelationId(DigestUtils.md5DigestAsHex(String.format("%s||%s||%s" ,refDEId,curDEId,relationCodeName).getBytes()));
                    }
                });
                fields.addAll(deField);
            }
            }
        );
        return fields;
    }

    /**
     * 获取实体关系
     * @return
     */
    public Collection<MetaRelationship>  getRelation(){
        Map<String,MetaRelationship>  relations =new HashMap<>();
        this.entities.forEach(entityNode->{
            List<MetaRelationship> parentRelation= entityNode.getParentEntitys();
            List<MetaRelationship> subRelation= entityNode.getSubEntitys();
            if(!ObjectUtils.isEmpty(parentRelation)){
                addToRelations(relations,parentRelation);
            }
            if(!ObjectUtils.isEmpty(subRelation)){
                addToRelations(relations,subRelation);
            }
        });
        return relations.values();
    }

    private void addToRelations(Map<String,MetaRelationship> relations, List<MetaRelationship> entityRelations){
        entityRelations.forEach(entityRelation->{
            entityRelation.setEntityId(DigestUtils.md5DigestAsHex(String.format("%s||%s" ,systemid,entityRelation.getEntityName()).getBytes()));
            entityRelation.setRefEntityId(DigestUtils.md5DigestAsHex(String.format("%s||%s" ,systemid,entityRelation.getRefEntityName()).getBytes()));
            String relationId = entityRelation.getId();
            if( !StringUtils.isEmpty(relationId) &&  !relations.containsKey(relationId)){
                relations.put(relationId,entityRelation);
            }
        });
    }
}
