package cn.ibizlab.core.lite.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.core.lite.domain.DstLookup;
import cn.ibizlab.core.lite.filter.DstLookupSearchContext;


/**
 * 实体[DstLookup] 服务对象接口
 */
public interface IDstLookupService{

    boolean create(DstLookup et) ;
    void createBatch(List<DstLookup> list) ;
    boolean update(DstLookup et) ;
    void updateBatch(List<DstLookup> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    DstLookup get(String key) ;
    DstLookup getDraft(DstLookup et) ;
    boolean checkKey(DstLookup et) ;
    boolean save(DstLookup et) ;
    void saveBatch(List<DstLookup> list) ;
    Page<DstLookup> searchDefault(DstLookupSearchContext context) ;
    List<DstLookup> selectByRelationid(String id) ;
    void removeByRelationid(String id) ;
    void saveByRelationid(String id,List<DstLookup> list) ;

}



